//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>

#define INITGUID
#include <dinput.h>

#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"


int gCount = 0;
int gCount2 = 0;
int gInterval = 0;
int gAlarm;
char str[50];
SYSTEMTIME	SystemTimeEntry;
int oldSec,newSec;
int oldSec2,newSec2;
int gBtnCaptionTgl = 0;


LPDIRECTINPUT8       g_pDI       = NULL; // The DirectInput object
LPDIRECTINPUTDEVICE8 g_pKeyboard = NULL; // The keyboard device


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
HRESULT         hr;
LPDIRECTINPUT8  g_lpDI;

        MediaPlayer1->FileName = ExtractFilePath(Application->ExeName)+"Alarm.wav";
        MediaPlayer1->Open();
        MediaPlayer2->FileName = ExtractFilePath(Application->ExeName)+"Alarm2.wav";
        MediaPlayer2->Open();

        SendMessage(ProgressBar1->Handle, PBM_SETBARCOLOR, 0, clGreen);

    hr = DirectInput8Create( GetModuleHandle(NULL), DIRECTINPUT_VERSION,
                                         IID_IDirectInput8, (VOID**)&g_pDI, NULL );
    hr = g_pDI->CreateDevice( GUID_SysKeyboard, &g_pKeyboard, NULL );
    hr = g_pKeyboard->SetDataFormat( &c_dfDIKeyboard );
    hr = g_pKeyboard->SetCooperativeLevel(Handle, DISCL_BACKGROUND | DISCL_NONEXCLUSIVE );
    g_pKeyboard->Acquire();



//        ((TSProgressBar *)ProgressBar1)->Color = clWhite;// Bar wiF

//        MediaPlayer1->Play();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
        BYTE byKeyState[256];
        g_pKeyboard->GetDeviceState( 256, byKeyState );

        if( byKeyState[DIK_RCONTROL] & 0x80 )
        {
                MediaPlayer2->Play();
                Button1Click(Sender);
                return;
        }


        GetSystemTime(&SystemTimeEntry);
        newSec = SystemTimeEntry.wSecond;
        if (newSec == oldSec)
                return;
        else
                oldSec = newSec;

        sscanf(Edit2->Text.c_str(),"%d",&gAlarm);
        gCount--;
        if (gCount < 0)
        {
                gCount = gInterval - 1;
                SendMessage(ProgressBar1->Handle, PBM_SETBARCOLOR, 0, clGreen);
        }
        sprintf(str,"%3d",gCount);
        Label1->Caption = str;
        Application->Title = str;
        ProgressBar1->Position = gCount;
        if (gAlarm == gCount)
        {
//                MediaPlayer1->FileName = ExtractFilePath(Application->ExeName)+"Alarm.wav";
//                MediaPlayer1->Open();
                MediaPlayer1->Play();
                SendMessage(ProgressBar1->Handle, PBM_SETBARCOLOR, 0, clRed);

        }

        Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        sscanf(Edit1->Text.c_str(),"%d",&gInterval);
        if (gInterval < 10 || gInterval > 99999)
                return;

        gCount =  gInterval;
        ProgressBar1->Max = gInterval;
        Timer1->Enabled = true;
        sprintf(str,"%3d",gCount);
        Label1->Caption = str;
        Application->Title = str;
        SendMessage(ProgressBar1->Handle, PBM_SETBARCOLOR, 0, clGreen);
        ProgressBar1->Position = gCount;
        GetSystemTime(&SystemTimeEntry);
        oldSec = newSec = SystemTimeEntry.wSecond;
        Application->ProcessMessages();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
        GetSystemTime(&SystemTimeEntry);
        newSec2 = SystemTimeEntry.wSecond;
        if (newSec2 == oldSec2)
                return;
        else
                oldSec2 = newSec2;

        gCount2++;
        if (gCount2 > 99999)
        {
                gCount2 = 0;
        }

        sprintf(str,"%3d",gCount2);
        Label3->Caption = str;
        Application->ProcessMessages();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
        if(gBtnCaptionTgl==0)
        {
                Button2->Caption = "vI";
                gCount2 = 0;
                Timer2->Enabled = true;
                gBtnCaptionTgl = 1;
        }
        else
        {
                Button2->Caption = "vJn";
                Timer2->Enabled = false;
                gBtnCaptionTgl = 0;
        }
        oldSec2 = newSec2 = SystemTimeEntry.wSecond;
}
//---------------------------------------------------------------------------

